from php5.my_long import *


class BoolZvalue(LongZvalue):
    def __init__(self, zend_value_raw_data, level=0):
        super().__init__(zend_value_raw_data, level)

    def __repr__(self):
        return self.get_data_to_print()

    def __str__(self):
        return self.get_data_to_print()

    def check_long(self):
        return self.value in [0, 1] and super(BoolZvalue, self).check_long()

    def get_data_to_print(self):
        indent = self.level * spacer
        if not self.is_valid():
            return indent + 'Invalid Bool'
        value = True if self.value else False
        args = {'indent': indent, 'value': value}
        if values_only:
            return '{indent}{value}'.format(**args)
        result = '{indent}Type: Bool\n{indent}Value: {value}\n'.format(
            **args)
        return result


if __name__ == '__main__':
    filename = '../dumps/core.2590'
    from php5.my_zval_struct import ZvalStruct
    from elf import get_segments, get_all_addresses

    segments = get_segments(filename)
    f = open(filename, 'rb')
    for address in get_all_addresses(segments):
        zval = ZvalStruct(f, segments, address, 0)
        if zval.is_valid() and zval.type == IS_BOOL:
            print(zval)
        del zval
    f.close()
