from _struct import *

from elf import *
from php5.my_types import *


class ConstantZvalue:
    def __init__(self, struct, level=0):
        self.struct, self.level = struct, level
        self.name, self.value = self.get_value(), 0  # TODO fix me
        self.valid = self.check()

    def is_valid(self):
        return self.valid

    def get_value(self):
        return unpack('<q', self.struct.data[:8])[0]

    def __repr__(self):
        return self.get_data_to_print()

    def __str__(self):
        return self.get_data_to_print()

    def check(self):
        return valid_address(self.get_value(),  # TODO change to normal string
                             self.struct.segments)

    def get_data_to_print(self):
        indent = self.level * spacer
        if values_only:
            return '{}{}({})'.format(indent, self.value, hex(self.value))
        if not self.is_valid():
            return '{}Invalid Long\n'.format(indent)
        args = {'indent': indent, 'virt': hex(self.struct.address),
                'offset': hex(self.struct.offset), 'info': self.struct.get_info()}
        # result = '{indent}Type: Constant\n{indent}Value: {string}({hvalue})\n{indent}Virtual address: {virt}\n{indent}File Offset: {offset}\n{info}'.format(
        #     **args)
        result = '{indent}Type: Constant\n{indent}Virtual address: {virt}\n{indent}File Offset: {offset}\n{info}'.format(
            **args)
        return result


if __name__ == '__main__':
    filename = '../dumps/core.2590'
    from php5.my_zval_struct import ZvalStruct
    from elf import get_segments

    segments = get_segments(filename)
    f = open(filename, 'rb')
    addr = 0x7f54c8b1e298
    zval = ZvalStruct(f, segments, addr, 0)
    if zval.is_valid():
        print(zval)
        # for address in get_all_addresses(segments):
        #     zval = ZvalStruct(f, segments, address, 0)
        #     if zval.is_valid() and zval.type == IS_CONSTANT:
        #         print(zval)
        #     del zval
        # f.close()
