from _struct import *

from php5.my_types import *


class DoubleZvalue:
    def __init__(self, raw_data, level=0):
        self.raw_data, self.level = raw_data, level
        self.value = self.get_value()[0]
        self.valid = self.check_double()

    def is_valid(self):
        return self.valid

    def get_value(self):
        return unpack('d', self.raw_data[:8])

    def __repr__(self):
        return self.get_data_to_print()

    def __str__(self):
        return self.get_data_to_print()

    def check_double(self):
        # return self.string != 0
        return True

    def get_data_to_print(self):
        indent = self.level * spacer
        if not self.is_valid():
            return '{}Invalid Double\n'.format(indent)
        if values_only:
            return '{}{}'.format(indent, self.value)
        args = {'indent': indent, 'value': self.value}
        result = '{indent}Type: Double\n{indent}Value: {value}\n'.format(
            **args)
        return result


# '0x5c0x2d0x660x6a0x820x2b0x340x41'
# '5c2d666a822b3441'
# 0x5c
# 0x2d
# 0x66
# 0x6a
# 0x82
# 0x2b
# 0x34
# 0x41

if __name__ == '__main__':
    filename = '../dumps/core.2590'
    from php5.my_zval_struct import ZvalStruct
    from elf import get_segments
    from php5.entry import init

    init(filename)
    addr = 0x7f54c8b1cdd0
    zval = ZvalStruct(addr, 0)
    if zval.is_valid():
        print(zval)
    # for address in get_all_addresses(segments):
        #     zval = ZvalStruct(address, 0)
    #     if zval.is_valid() and zval.type == IS_DOUBLE:
    #         print(zval)
    #     del zval
