from _struct import *
from php5.my_types import *


class LongZvalue:
    def __init__(self, zend_value_raw_data, level=0):
        self.raw_data, self.level = zend_value_raw_data, level
        self.value = self.get_value()[0]
        self.valid = self.check_long()

    def is_valid(self):
        return self.valid

    def get_value(self):
        return unpack('<q', self.raw_data[:8])

    def __repr__(self):
        return self.get_data_to_print()

    def __str__(self):
        return self.get_data_to_print()

    def check_long(self):
        return True

    def get_data_to_print(self):
        indent = self.level * spacer
        if not self.is_valid():
            return '{}Invalid Long\n'.format(indent)
        if values_only:
            return '{}{}({})'.format(indent, self.value, hex(self.value))
        args = {'indent': indent, 'value': self.value, 'hvalue': hex(self.value)}
        result = '{indent}Type: Long\n{indent}Value: {value}({hvalue})\n'.format(
            **args)
        return result


if __name__ == '__main__':
    filename = '../dumps/core.2590'
    from php5.my_zval_struct import ZvalStruct
    from elf import get_segments
    from php5.entry import init

    init(filename)
    addr = 0x7f54c8b1e298
    zval = ZvalStruct(addr, 0)
    if zval.is_valid():
        print(zval)
        # for address in get_all_addresses(segments):
        #     zval = ZvalStruct( address, 0)
        #     if zval.is_valid() and zval.type == IS_LONG:
        #         print(zval)
        #     del zval
