from php5.my_long import *


class ResourceZvalue(LongZvalue):
    def __init__(self, zend_value_raw_data, level=0):
        super().__init__(zend_value_raw_data, level)

    def __repr__(self):
        return self.get_data_to_print()

    def __str__(self):
        return self.get_data_to_print()

    def check_long(self):
        # return super(ResourceZvalue, self).check_long() and self.string > 0
        return super(ResourceZvalue, self).check_long()

    def get_data_to_print(self):
        indent = self.level * spacer
        if values_only:
            return '{}{}({})(resource)'.format(indent, self.value, hex(self.value))
        if not self.is_valid():
            return '{}Invalid Resource'.format(indent)
        args = {'indent': indent, 'value': self.value, 'hvalue': hex(self.value)}
        result = '{indent}Type: Resource\n{indent}Value: {value}({hvalue})\n'.format(
            **args)
        return result


if __name__ == '__main__':
    filename = '../dumps/core.2590'
    from php5.my_zval_struct import ZvalStruct
    from elf import get_all_addresses
    from php5.entry import init, get_glob_segments

    init(filename)

    for address in get_all_addresses(get_glob_segments()):
        zval = ZvalStruct(address, 0)
        if zval.is_valid() and zval.type == IS_RESOURCE:
            print(zval)
        del zval
