from struct import unpack

from elf import valid_address, get_offset
from php5.entry import get_glob_segments, get_data
from php5.my_types import spacer


class CompiledVar:
    def __init__(self, address, level=0) -> None:
        self.address = address
        self.level = level
        self.name = ''
        if valid_address(self.address, get_glob_segments()):
            self.offset = get_offset(self.address, get_glob_segments())
            self.data = get_data(self.offset, 12)
            self.name_p, self.length = unpack('Qi', self.data)
            self.valid = False
            if valid_address(self.name_p, get_glob_segments()):
                if self.length == 0:
                    self.name = ''
                else:
                    self.name_o = get_offset(self.name_p, get_glob_segments())
                    self.name = get_data(self.name_o, self.length)
                self.valid = True

    def is_valid(self):
        return self.valid

    def get_data_to_print(self):
        if not self.valid:
            return 'Invalid name'
        return str(self.level * spacer) + '>' + str(self.name)

    def __repr__(self) -> str:
        return self.get_data_to_print()

    def __str__(self) -> str:
        return self.get_data_to_print()
