from elf import get_segments
from struct import unpack

# /* regular data types */
IS_UNDEF = 0
IS_NULL = 1
IS_FALSE = 2
IS_TRUE = 3
IS_LONG = 4
IS_DOUBLE = 5
IS_STRING = 6
IS_ARRAY = 7
IS_OBJECT = 8
IS_RESOURCE = 9
IS_REFERENCE = 10

# /* constant expressions */
IS_CONSTANT = 11
IS_CONSTANT_AST = 12

# /* fake types */
_IS_BOOL = 13
IS_CALLABLE = 14
IS_ITERABLE = 19
IS_VOID = 18

# /* internal types */
IS_INDIRECT = 15
IS_PTR = 17
_IS_ERROR = 20

values_only = 1

UNSPECIFIED = 0
CLASS_ENTRY = 1
CONSTANT = 2
FUNCTION = 3


def parse_refcounted_v(data):
    return unpack(refcounted_format_v, data)


def parse_refcounted_t(data):
    return unpack(refcounted_format_t, data)


def parse_refcounted(data):
    return parse_refcounted_v(data)


refcounted_format_v = 'IBBH'
refcounted_format_t = 'II'

zvalue_format_p = 'Q'
zvalue_format_l = 'q'

zvalue_format_d = 'd'
zvalue_format_ww = 'II'

# zval_format_v = ""
# zval_format_t = ""

refcounted_size = 8
zval_size = 16
zvalue_size = 8
bucket_size = 32
array_size = 56
reference_size = 24
resource_size = 24
function_size_partial = 56
arg_info_size = 24
execute_data_partial = 64
spacer = "    "

oparray_partial_size = 88
deprecation_size = 0x4000
