from elf import valid_address, get_offset
from php7.at_start.entry import get_glob_segments, get_data
from php7.at_start.my_globals import *


# TODO doesn't work
class ConstantZvalue:
    def __init__(self, zvalue_raw_data, level=0) -> None:
        self.__zvalue_raw_data = zvalue_raw_data
        self.__level = level
        self.__address = unpack(zvalue_format_p, self.__zvalue_raw_data)[0]
        self.__valid_address = valid_address(self.__address, get_glob_segments())
        self.__valid = False
        if self.__valid_address:
            from php7.zval_struct import ZvalStruct
            from php7.string_zvalue import StringZvalue
            self.__offset = get_offset(self.__address, get_glob_segments())
            self.__zend_string = StringZvalue(get_data(self.__offset, 8), self.__level + 1)
            # self.__zend_string = ZvalStruct(self.__address, self.__level + 1)
            self.__valid = self.__check_valid()
            # self.__valid = True

    def is_valid(self):
        return self.__valid

    def __check_valid(self):
        return self.__zend_string.is_valid()
        # return self.__zend_string.is_valid() and self.__zend_string.get_type() == IS_STRING

    def __get_data_to_print(self):
        indent = self.__level * spacer
        if not self.is_valid():
            return '{}Invalid Constant\n'.format(indent)
        # string = None if self.__zend_string is None else self.__zend_string.get_string()
        string = self.__zend_string
        args = {'indent': indent, 'h_address': hex(self.__address), 'h_offset': hex(self.__offset),
                'address': int(self.__address), 'offset': int(self.__offset), 'key': string}
        if values_only:
            # return '{indent}>Name: {key}\n'.format(**args)
            return '{indent}>Name: {h_address}\n{key}'.format(**args)
        else:
            return ''

    def __str__(self) -> str:
        return self.__get_data_to_print()

    def __repr__(self) -> str:
        return self.__get_data_to_print()


if __name__ == "__main__":
    filename = '../dumps/php7/core.7058'
    filename = '../dumps/php7/core.3175'
    filename = '../dumps/php7/core.6128'
    filename = '../dumps/php7/core.9169'
    from php7.at_start.entry import init

    init(filename)
    from php7.zval_struct import ZvalStruct
    from elf import get_all_addresses

    # for address in [0x563f7bb0e740, 0x7fa93a2629e0, 0x7fa93a269490, 0x7fa93a27cae8]:
    # for address in get_all_addresses(get_glob_segments()):
    #     zval = ConstantZvalue(pack('Q', address), 0)
    #     if zval.is_valid():
    #         print(zval)

    for address in get_all_addresses(get_glob_segments()):
        zval = ZvalStruct(address, 0)
        if zval.is_valid() and zval.get_type() == IS_CONSTANT:
            print(zval)
