from elf import valid_address, get_all_addresses
from php7.at_start.entry import init, get_glob_segments
from php7.at_start.my_globals import *


class IndirectZvalue:
    def __init__(self, raw_data, level=0) -> None:
        self.__zvalue_raw_data = raw_data
        self.__level = level
        self.__address = unpack('Q', self.__zvalue_raw_data)[0]
        self.__valid_address = valid_address(self.__address, get_glob_segments())
        self.__valid = False
        if self.__valid_address:
            from php7.zval_struct import ZvalStruct
            # self.__zval = ZvalStruct(self.__address, self.__level + 1)
            self.__zval = ZvalStruct(self.__address, self.__level)
            self.__valid = self.__check_valid()

    def is_valid(self):
        return self.__valid

    def __check_valid(self):
        # return self.__zval.is_valid() and self.__zval.get_type() is not IS_UNDEF
        return self.__zval.is_valid()

    def __get_data_to_print(self):
        indent = self.__level * spacer
        if not self.is_valid():
            return '{}Invalid Indirect\n'.format(indent)
        args = {'indent': indent, 'zval': self.__zval}
        if values_only:
            # return '{indent}Indirect:\n{zval}'.format(**args)
            return '{zval}'.format(**args)
        else:
            return '{indent}Type: Indirect\n{zval}'.format(
                **args)

    def __str__(self) -> str:
        return self.__get_data_to_print()

    def __repr__(self) -> str:
        return self.__get_data_to_print()


if __name__ == "__main__":
    # filename = '../dumps/php7/core.7058'
    # filename = '../dumps/php7/core.3175'
    # filename = '../dumps/php7/core.6128'
    filename = '../dumps/php7/core.5834'
    filename = '../dumps/php7/core.28039'
    from php7.zval_struct import ZvalStruct
    from struct import pack

    init(filename)

    for address in get_all_addresses(get_glob_segments()):
        zval = ZvalStruct(address, 0)
        if zval.is_valid() and zval.get_type() == IS_INDIRECT:
            print(zval)
        del zval

        # for address in get_all_addresses(get_glob_segments()):
        #     zval = IndirectZvalue(pack('Q',address), 0)
        #     if zval.is_valid() :
        #         print(zval)
        #     del zval
