from php7.at_start.my_globals import *


class LongZvalue:
    def __init__(self, zvalue_raw_data, level) -> None:
        self.__zvalue_raw_data = zvalue_raw_data
        self.__level = level
        self.__valid = True
        self.__number = unpack(zvalue_format_l, zvalue_raw_data)[0]

    def is_valid(self):
        return self.__valid

    def __repr__(self):
        return self.get_data_to_print()

    def __str__(self):
        return self.get_data_to_print()

    def get_data_to_print(self):
        indent = self.__level * spacer
        if not self.is_valid():
            return '{}Invalid Long\n'.format(indent)
        if values_only:
            return '{}{}({})'.format(indent, self.__number, hex(self.__number))
        args = {'indent': indent, 'value': self.__number, 'hvalue': hex(self.__number)}
        result = '{indent}Type: Long\n{indent}Value: {value}({hvalue})\n'.format(
            **args)
        return result


if __name__ == "__main__":
    filename = '../dumps/php7/core.7058'
    from php7.zval_struct import ZvalStruct
    from php7.at_start.entry import init

    init(filename)

    addr = 0x7f7c286120b0
    print(ZvalStruct(addr))

    # for address in get_all_addresses(get_glob_segments()):
    #     zval = ZvalStruct(address, 0)
    #     if zval.is_valid() and zval.get_type() == IS_LONG:
    #         print(zval)
    #     del zval
